<?php

// Attributes forms
// WooCommerce shipping methods list
if ( isset( $_POST['mondialrelay_ids_livraison'] ) && $_POST['mondialrelay_ids_livraison'] != '' ) {
    foreach ( $_POST['mondialrelay_ids_livraison'] as $id ) {
        /*
          @todo check validity of entry or change data structure
          Format:
            [0] => flat_rate:1-LD1
            [1] => local_pickup:2-24R
        */
        $mondialrelay_ids_livraison[] = $id;
    }
}
else {
    $mondialrelay_ids_livraison = ''; // Pas un array() ?
}

// Mondial Relay state order parameter form
if ( isset( $_POST['mondialrelay_state_order']) && $_POST['mondialrelay_state_order'] != '' ) {
    $mondialrelay_state_order = sanitize_key( $_POST['mondialrelay_state_order'] );
}
else {
    $mondialrelay_state_order = '';
}

// Mondial Relay state order parameter form
if ( isset( $_POST['mondialrelay_state_order_delivered']) && $_POST['mondialrelay_state_order_delivered'] != '' ) {
    $mondialrelay_state_order_delivered = sanitize_key( $_POST['mondialrelay_state_order_delivered'] );
}
else {
    $mondialrelay_state_order_delivered = '';
}

// Save the attributes forms
$champs = array(
    'mondialrelay_state_order'           => $mondialrelay_state_order,
    'mondialrelay_state_order_delivered' => $mondialrelay_state_order_delivered,
);

// Labels of the Mondial Relay state order parameter form
$labels_livraison['mondialrelay_ids_livraison']['type'] = "select";
$labels_livraison['mondialrelay_ids_livraison']['options'] = array(
    '24R' =>__('24R - livraison en Point Relais®', 'mondialrelay-wordpress'),
    'DRI' =>__('DRI - livraison en Colis Drive', 'mondialrelay-wordpress'),
    'HOM' =>__('HOM - livraison domicile HOME', 'mondialrelay-wordpress'),
    'LD1' =>__('LD1 - livraison HOME 1', 'mondialrelay-wordpress'),
    'LDS' =>__('LDS - livraison HOME 2 ', 'mondialrelay-wordpress'),
    'HOC' =>__('HOC - livraison HOC', 'mondialrelay-wordpress'),
    'HOD' =>__('HOD - livraison HOD', 'mondialrelay-wordpress')
);

// Labels of the Mondial Relay state order parameter form
$labels_order['mondialrelay_state_order']['label'] = __( 'État de la commande à la création', 'mondialrelay-wordpress' );
$labels_order['mondialrelay_state_order']['description'] = __( 'État de commande à la création d’une expédition Mondial Relay. Ex: Ne rien faire (par défault)', 'mondialrelay-wordpress' );
// Get all WooCommerce status including custom ones
$labels_order['mondialrelay_state_order']['options'] = wc_get_order_statuses();

$labels_order['mondialrelay_state_order_delivered']['label'] = __( 'État de la commande à la livraison', 'mondialrelay-wordpress' );
$labels_order['mondialrelay_state_order_delivered']['description'] = __( 'État de commande après livraison d’une expédition Mondial Relay. Ex: Ne rien faire (par défault)', 'mondialrelay-wordpress' );
$labels_order['mondialrelay_state_order_delivered']['options'] = wc_get_order_statuses();

// Update options
if ( isset( $_POST['submit'] ) ) {
    $envoi = 1;
    $noty = 1;
    class_MRWP_db::update_options_champs( $champs );
    update_option( 'mondialrelay_ids_livraison', $mondialrelay_ids_livraison );

    // Sync shipping method with WooCommerce shipping zone parameters
    class_MRWP_main::load_shipping_class();

    foreach ( $mondialrelay_ids_livraison as $id ) {

        // Is it one of our own?
        if ( 0 === strpos( $id, MRWP_Shipping_Method::$method_id . ':' ) ) {

            // Extract values from concatenated string
            list( $instance, $code )      = explode( '-', $id );
            list( $unused, $instance_id ) = explode( ':', $instance );

            // Retrieve value
            $option_name  = implode( '_', [ 'woocommerce', MRWP_Shipping_Method::$method_id, $instance_id, 'settings' ] );
            $option_value = get_option( $option_name );

            // Sanity check and update value
            if ( isset( $option_value['method'] ) ) {
                $option_value['method'] = $code;
                update_option( $option_name, $option_value );
            }
        }
    }
}

// Get the options
$champs = class_MRWP_db::get_options_champs( $champs );
$mondialrelay_ids_livraison = class_MRWP_db::get_options_champ( 'mondialrelay_ids_livraison' );
$mondialrelay_ids_livraison = unserialize($mondialrelay_ids_livraison);

if (version_compare(class_MRWP_main::woocommerce_version(), '2.6.0', '>=')) {
    // Get WooCommerce shipping methods
    $shipping_methods = class_MRWP_db::get_shipping_methods();

    $mondialrelay_shipping_methods = array();
    foreach($shipping_methods as $key => $shipping_method) {
        $mondialrelay_shipping_methods[$key] = array(
            'id' => $shipping_method->method_id . ':' . $shipping_method->instance_id,
            'zone' => class_MRWP_helpers::get_shipping_zone_name($shipping_method->zone_id),
            'name' => class_MRWP_helpers::get_shipping_method_name($shipping_method->method_id),
            'title' => class_MRWP_db::get_shipping_method_title($shipping_method->method_id, $shipping_method->instance_id),
        );

    }

}