<?php

// Debug mode
$mondialrelay_debug = get_option( 'mondialrelay_debug');

// Test Mondial Relay webservice (Search point - SOAP)

if (isset($_POST['webservice'])) {

    // Get Mondial Relay global parameters
    $mondialrelay_code_client = get_option( 'mondialrelay_code_client', 1 );
    $mondialrelay_code_marque = get_option( 'mondialrelay_code_marque', 1 );
    $mondialrelay_cle_privee = get_option( 'mondialrelay_cle_privee', 1 );
    $client = new SoapClient(class_MRWP_main::MONDIALRELAY_WEBSERVICE);
    $params = array(
        'Enseigne' => $mondialrelay_code_client,
        'Pays'     => 'FR',
        'Ville'    => '',
        'CP'       => '40000',
        'Poids'    => '1000'
    );
 
    // Generation of the security key
    $code = implode("", $params);
    $code .= $mondialrelay_cle_privee;
    $params["Security"] = strtoupper(md5($code));

    try{
        $recherche = $client->WSI4_PointRelais_Recherche($params)->WSI4_PointRelais_RechercheResult;
        $noty = 6;
        $callback = $recherche->STAT;
    } catch(Exception $e){
        $debug_except .= $e;
        $callback = 789;
    }

    // Status code
    if ($callback != 0) {
        $libelle_retour = class_MRWP_helpers::statut($callback);
    }

    // Check required vendor's contact details
    elseif ($callback == 0) {
        // Get sender's parameters
        $params_expediteur = class_MRWP_order::get_params_expediteur();
        // Get addressee's parameters

        $params_vendeur = array(
            'Enseigne'        => class_MRWP_main::ENSEIGNE
            ,'ModeCol'        => class_MRWP_main::MODE_COL
            ,'ModeLiv'        => "24R"
            ,'Expe_Langage'   => $params_expediteur['mondialrelay_vendeur_langage']
            ,'Expe_Ad1'       => $params_expediteur['mondialrelay_vendeur_adresse1']
            ,'Expe_Ad3'       => $params_expediteur['mondialrelay_vendeur_adresse3']
            ,'Expe_Ad4'       => "Test"
            ,'Expe_Ville'     => $params_expediteur['mondialrelay_vendeur_ville']
            ,'Expe_CP'        => $params_expediteur['mondialrelay_vendeur_cp']
            ,'Expe_Pays'      => $params_expediteur['mondialrelay_vendeur_pays']
            ,'Expe_Tel1'      => $params_expediteur['mondialrelay_vendeur_tel']
            ,'Expe_Mail'      => $params_expediteur['mondialrelay_vendeur_email']
            ,'Dest_Langage'   => "FR"
            ,'Dest_Ad1'       => "Test Test"
            ,'Dest_Ad3'       => "Test"
            ,'Dest_Ville'     => "Test"
            ,'Dest_CP'        => "75000"
            ,'Dest_Pays'      => "FR"
            ,'Dest_Tel1'      => "0100000000"
            ,'Dest_Mail'      => "test@test.fr"
            ,'Poids'          => 1000
            ,'NbColis'        => '1'
            ,'CRT_Valeur'     => '0'
            ,'LIV_Rel_Pays'   => "FR"
            ,'LIV_Rel'        => "021490"
        );

        // Generation of the security key
        $code = implode("", $params_vendeur);
        $code .= 'PrivateK';
        $params_vendeur["Security"] = strtoupper(md5($code));

        // Create the expedition

        try{
            $expedition = $client->WSI2_CreationExpedition($params_vendeur)->WSI2_CreationExpeditionResult;
            $vendeur = $expedition->STAT;
        } catch(Exception $e){
            $debug_except .= $e;
            $vendeur = 789;
        }

        // Status code
        if ($vendeur != 0) {
            $libelle_vendeur_retour = class_MRWP_helpers::statut($vendeur);
        }
    }
}

